/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2007-2009 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_support.S 474 2007-08-10 06:59:23Z honda $
 */

/*
 *  åȰ¸⥸塼 ֥APSH2A
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"

/*
 *  ٥ΥåȰ¸ν
 *
 *  ȥåץ⥸塼ǡν˸ƤӽФ롥
 */

/*
 *  ROMˡDATAΥ0ȡBSSTXTľ֤
 *  뤿ᡤDATAΥ0ˤʤΥߡѿ
 *  ѥκŬˤΤɤᡢ֥ǵҤ
 *  Ƥ롣
 */
    .data
_dummy:
	.long 0x00000000

    .text
    .globl _hardware_init_hook
_hardware_init_hook:
	/* åȯ(CPG) */
    /* I=160Mhz,B=40Mhz,P=40Mhz */
	mov.l _frqcr_addr, r1
	mov.l _frqcr_val, r2
	mov.w r2, @r1

	/* ƥॳȥ쥸 */
		/*  RAMͭ  */
	mov.l _sys_cr1_addr, r1
	mov.l _sys_cr1_val, r2
	mov.b r2, @r1
	mov.l _sys_cr2_addr, r1
	mov.l _sys_cr2_val, r2
	mov.b r2, @r1

	/* Хȥ */
	mov.l _cmncr_addr, r1
	mov.l _cmncr_val, r2
	mov.l r2, @r1
	mov.l _cs3bcr_addr, r1
	mov.l _cs3bcr_val, r2
	mov.l r2, @r1
	mov.l _cs3wcr_addr, r1
	mov.l _cs3wcr_val, r2
	mov.l r2, @r1
	mov.l _sdcr_addr, r1
	mov.l _sdcr_val, r2
	mov.l r2, @r1
	mov.l _rtcsr_addr, r1
	mov.l _rtcsr_val, r2
	mov.l r2, @r1
	mov.l _rtcor_addr, r1
	mov.l _rtcor_val, r2
	mov.l r2, @r1

	/* SDRAM ³ݡȤν */
	mov.l _pacrl4_addr, r1
	mov.l _pacrl4_val, r2
	mov.w r2, @r1
	mov.l _pacrl3_addr, r1
	mov.l _pacrl3_val, r2
	mov.w r2, @r1
	mov.l _pacrl2_addr, r1
	mov.l _pacrl2_val, r2
	mov.w r2, @r1
	mov.l _pacrl1_addr, r1
	mov.l _pacrl1_val, r2
	mov.w r2, @r1

	mov.l _pbiorh_addr, r1
	mov.l _pbiorh_val, r2
	mov.w r2, @r1
	mov.l _pbiorl_addr, r1
	mov.l _pbiorl_val, r2
	mov.w r2, @r1
	mov.l _pbcrh1_addr, r1
	mov.l _pbcrh1_val, r2
	mov.w r2, @r1
	mov.l _pbcrl3_addr, r1
	mov.l _pbcrl3_val, r2
	mov.w r2, @r1
	mov.l _pbcrl2_addr, r1
	mov.l _pbcrl2_val, r2
	mov.w r2, @r1
	mov.l _pbcrl1_addr, r1
	mov.l _pbcrl1_val, r2
	mov.w r2, @r1

	mov.l _pdior_addr, r1
	mov.l _pdior_val, r2
	mov.w r2, @r1
	mov.l _pdcrl4_addr, r1
	mov.l _pdcrl4_val, r2
	mov.w r2, @r1
	mov.l _pdcrl3_addr, r1
	mov.l _pdcrl3_val, r2
	mov.w r2, @r1
	mov.l _pdcrl2_addr, r1
	mov.l _pdcrl2_val, r2
	mov.w r2, @r1
	mov.l _pdcrl1_addr, r1
	mov.l _pdcrl1_val, r2
	mov.w r2, @r1


	/*
	 *  100usecԤ
	 */
	mov.l _cmstr_addr, r1
	mov   #0, r2
	mov.w r2, @r1
	mov.l _cmcsr_0_addr, r1
	mov.w r2, @r1
	mov.l _cmcnt_0_addr, r1
	mov.w r2, @r1
	mov.l _cmcor_0_addr, r1
	mov.l _cmcor_0_val,  r2
	mov.w r2, @r1
	mov.l _cmstr_addr, r1
	mov   #1, r2
	mov.w r2, @r1
	mov.l _cmcsr_0_addr, r1
	mov.l _cmcsr_cmf, r2
1:
	mov.w @r1, r3
	tst   r2, r3
	bt    1b

	mov.l _sdram_mode_addr, r1
	mov.l _sdram_mode_val,  r2

    rts
	 mov.w r2, @r1

	.align 4
_frqcr_addr:
	.long FRQCR
_frqcr_val:
	.long 0x1303

_sys_cr1_addr:
	.long SYSCR1
_sys_cr1_val:
	.long 0xff
_sys_cr2_addr:
	.long SYSCR2
_sys_cr2_val:
	.long 0xff

_cmncr_addr:
	.long CMNCR
_cmncr_val:
	.long 0x00001010
_cs3bcr_addr:
	.long CS3BCR
_cs3bcr_val:
	.long 0x00004400
_cs3wcr_addr:
	.long CS3WCR
_cs3wcr_val:
	.long 0x00002491
_sdcr_addr:
	.long SDCR
_sdcr_val:
	.long 0x00000909
_rtcsr_addr:
	.long RTCSR
_rtcsr_val:
	.long 0xa55a0008
_rtcor_addr:
	.long RTCOR
_rtcor_val:
	.long 0xa55a009c

_pacrl4_addr:
	.long PACRL4
_pacrl4_val:
	.long 0x1111
_pacrl3_addr:
	.long PACRL3
_pacrl3_val:
	.long 0x1111
_pacrl2_addr:
	.long PACRL2
_pacrl2_val:
	.long 0x1111
_pacrl1_addr:
	.long PACRL1
_pacrl1_val:
	.long 0x1110

_pbiorh_addr:
	.long PBIORH
_pbiorh_val:
	.long 0x0000
_pbiorl_addr:
	.long PBIORL
_pbiorl_val:
	.long 0x0000
_pbcrh1_addr:
	.long PBCRH1
_pbcrh1_val:
	.long 0x0010
_pbcrl3_addr:
	.long PBCRL3
_pbcrl3_val:
	.long 0x0011
_pbcrl2_addr:
	.long PBCRL2
_pbcrl2_val:
	.long 0x0111
_pbcrl1_addr:
	.long PBCRL1
_pbcrl1_val:
	.long 0x1010

_pdior_addr:
	.long PDIOR
_pdior_val:
	.long 0x0000
_pdcrl4_addr:
	.long PDCRL4
_pdcrl4_val:
	.long 0x1111
_pdcrl3_addr:
	.long PDCRL3
_pdcrl3_val:
	.long 0x1111
_pdcrl2_addr:
	.long PDCRL2
_pdcrl2_val:
	.long 0x1111
_pdcrl1_addr:
	.long PDCRL1
_pdcrl1_val:
	.long 0x1111

_cmstr_addr:
	.long CMSTR
_cmcsr_0_addr:
	.long CMCSR_0
_cmcnt_0_addr:
	.long CMCNT_0
_cmcor_0_addr:
	.long CMCOR_0
_cmcor_0_val:
	.long ((((PCLOCK / 8)/1000000) * 100)-1)
_cmcsr_cmf:
	.long CMCSR_CMF

_sdram_mode_addr:
	.long 0xfffc5040
_sdram_mode_val:
	.long 0x000
