/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2007-2009 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.h 696 2007-12-25 04:42:33Z honda $
 */

/*
 *  åȰ¸⥸塼APSH2Aѡ
 *
 *  ͥΥåȰ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  åȥƥΥϡɥ񸻤
 */
#include "apsh2a.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"

/*
 *  Ϥ̤
 *  ɬפ˱asp/arch/logtrace/trace_dump.ctrace_print()
 *  б̤ɵ롣
 */
#define LOG_INH_ENTER			/*   17(0x11)  */
#define LOG_INH_LEAVE			/*  145(0x91)  */
#define LOG_EXC_ENTER			/*   22(0x16)  */
#define LOG_EXC_LEAVE			/*  150(0x96)  */

#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  åȰ¸ʸϤ˻ѤݡȤ
 */
#define TARGET_PUTC_PORTID 2

/*
 *  ASPͥưΥޥåפȴϢ
 */

/*
 *  ǥեȤ󥿥ƥѤΥåΰ
 */
#ifdef ROM_BOOT				/*  ROM  */
#define DEFAULT_ISTKSZ    0x8000U
#else	/*  ROM_BOOT  */	/*  ǥХå  */
#define DEFAULT_ISTKSZ    0x2000U
#endif /*  ROM_BOOT  */

/*  åΰƬϡʥåΰǤϤʤΤǡա */
#define DEFAULT_ISTK      (void *)(DEFAULT_STK_TOP - DEFAULT_ISTKSZ)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  åȥƥ¸ν
 */
extern void target_initialize(void);

/*
 *  åȥƥνλ
 *
 *  ƥλ˻Ȥ
 */
extern void target_exit(void) NoReturn;

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ԤΤSILΥåȰ¸
 */
#ifdef ROM_BOOT		/*  ROMξ  */
#define SIL_DLY_TIM1     75
#define SIL_DLY_TIM2     21

#else				/*  RAMǥǥХå  */
#define SIL_DLY_TIM1     1670
#define SIL_DLY_TIM2      906

#endif

/*
 *  ץå¸⥸塼SH7211ѡ
 */
#include "sh12a_gcc/sh7211_config.h"

#endif  /* TOPPERS_TARGET_CONFIG_H */
