/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_syssvc.h 696 2007-12-25 04:42:33Z honda $
 */

/*
 *  ƥॵӥΥåȰ¸APSH2Aѡ
 *
 *  ƥॵӥΥåȰ¸Υ󥯥롼ɥե롥Υե
 *  Ƥϡݡͥȵҥե˵Ҥ졤Υե
 *  ̵ʤ븫ߡ
 */

#ifndef TOPPERS_TARGET_SYSSVC_H
#define TOPPERS_TARGET_SYSSVC_H

/*
 *  åȥƥΥϡɥ񸻤
 */
#include "apsh2a.h"

/*
 *  ץå¸
 */
#include "sh12a_gcc/prc_syssvc.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_TRACE_ENABLE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_TRACE_ENABLE */

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME    "APSH2A(SH7211)"

/*
 *  ưå˥åȰ¸ɽ
 *  ɲä뤿Υޥ
 */
#ifdef PRC_COPYRIGHT
#define TARGET_COPYRIGHT	PRC_COPYRIGHT
#endif /* PRC_COPYRIGHT */

/*
 *  ƥ٥ϤΤʸ
 *
 *  åȰ¸ˡǡʸcɽ//¸롥
 */
extern void	target_fput_log(char_t c);

/*
 *  ꥢݡȿ
 */
#define TNUM_PORT        2        /* ݡȤ륷ꥢݡȤο */
#define TNUM_SIOP        2

/*
 *  Ѥ륷ꥢݡID
 */
#define SIO_PORTID   2

#define LOGTASK_PORTID   SIO_PORTID

/*
 *  ܡ졼
 */
#define BPS_SETTING 38400
#define SCIF0_BPS_SETTING  (((PCLOCK / 32) / BPS_SETTING) - 1)
#define SCIF1_BPS_SETTING  (((PCLOCK / 32) / BPS_SETTING) - 1)

/*
 *  ֹ
 */
#define SCIF0_RXI_INTNO   			SCIF0_RXI_VECTOR
#define SCIF0_TXI_INTNO   			SCIF0_TXI_VECTOR
#define SCIF1_RXI_INTNO   			SCIF1_RXI_VECTOR
#define SCIF1_TXI_INTNO   			SCIF1_TXI_VECTOR
#define SCIF2_RXI_INTNO   			SCIF2_RXI_VECTOR
#define SCIF2_TXI_INTNO   			SCIF2_TXI_VECTOR

/*
 *  ƥϢ
 *
 *  ǥե̤ͤꡥ
 */

#endif /* TOPPERS_TARGET_SYSSVC_H */
